#define _SUPPRESS_PLIB_WARNING
#include <plib.h>
#define FAM
#include "APIDefs.h"
#define cport *(volatile unsigned int *)(0xbf886230) //latch registers
#define csetport *(volatile unsigned int *)(0xbf886238) //latch registers
#define cclrport *(volatile unsigned int *)(0xbf886234) //latch registers
#define devid *(volatile unsigned int *)(0xBF80F220) //Device ID
#define wr 512 // WR is on pin C09
#define rs params[7]
#define command(a) {PinSetBit(rs, LATCLR);cport=a;cclrport=wr;csetport=wr;}
#define data(a) {PinSetBit(rs, LATSET);cport=a;cclrport=wr;csetport=wr;}
#define psend(a) {cport=a;cclrport=wr;csetport=wr;}
#define CurrentX params[4]
#define CurrentY params[5]
#define localdrawPixel(a,b,c,d) localfastfillrect(a,b,c,1,1,d)
//

void writeCommand(unsigned long command, long long params[]){
  PinSetBit(rs, LATCLR);
  psend(command);
}
void writeData(unsigned long databyte, long long params[]){ //write just the bottom 9 bits
  unsigned long j;
  PinSetBit(rs, LATSET);
  psend(databyte);
}

void setxy(unsigned long xstart, unsigned long xend, unsigned long ystart, unsigned long yend, long long params[]){
    unsigned long j;
    command(0x2A);
    data(xstart>>8);
    data(xstart);
    data(xend>>8);
    data(xend);
    command(0x2B);
    data(ystart>>8);
    data(ystart);
    data(yend>>8);
    data(yend);
    command(0x2C);
      }
long long localfastfillrect(long fc,long long x,
    long long y, long long width,long long height, long long params[]){
    long long x1=x,x2=x+width-1,y1=y,y2=y+height-1;
    unsigned long i,j,ch,cl,s_col,e_col,s_page,e_page;
    unsigned long SSD1963DISPLAYWIDTH=params[0];
    unsigned long SSD1963DISPLAYHEIGHT=params[1];
    unsigned long rotation=params[2];
    if(rotation==0){
              s_col = y1;
              e_col = y2;
              s_page = (unsigned short)((SSD1963DISPLAYHEIGHT - 1) - (x2));
              e_page = (unsigned short)((SSD1963DISPLAYHEIGHT - 1) - (x1));
     }
     if(rotation==1){
              s_col = (unsigned short)((SSD1963DISPLAYWIDTH - 1) - (y2));
              e_col = (unsigned short)((SSD1963DISPLAYWIDTH - 1) - y1);
              s_page = x1;
              e_page = x2;
      }
     if(rotation==2){
              s_col = x1;
              e_col = x2;
              s_page = y1;
              e_page = y2;
     }
      if(rotation==3){
              s_col = (unsigned short)((SSD1963DISPLAYWIDTH - 1) - (x2));
              e_col = (unsigned short)((SSD1963DISPLAYWIDTH - 1) - (x1));
              s_page = (unsigned short)((SSD1963DISPLAYHEIGHT - 1) - (y2));
              e_page = (unsigned short)((SSD1963DISPLAYHEIGHT - 1) - (y1));
      }

        i=x2-x1+1;
        i*=(y2-y1+1);
        writeCommand(0x44, params);
        setxy(s_col,e_col,s_page,e_page, params);
    // convert the colours to 666 format
       ch = ((fc >> 15) & 0b111111000) | ((fc >> 13) & 0b000000111);
       cl = ((fc >>  4) & 0b111000000) | ((fc >>  2) & 0b000111111);
       PinSetBit(rs, LATSET);
        while (i--) {
          psend(ch);
          psend(cl);
        }
        return 1;
}
//Print the bitmap of a char on the video output
//    x, y - the top left of the char
//    width, height - size of the char's bitmap
//    scale - how much to scale the bitmap
//	  fc, bc - foreground and background colour
//    bitmap - pointer to the butmap
void DBitmap(int x1, int y1, int width, int height, int scale, int fc, int bc, unsigned char bitmap[], long long params[] ){
    int i, j, k, m,x2=x1+(width*scale)-1,y2=y1+(height*scale)-1,s_col,e_col,s_page,e_page;
    unsigned int fhb, flb, bhb, blb, xtest, ytest;
    unsigned long SSD1963DISPLAYWIDTH=params[0];
    unsigned long SSD1963DISPLAYHEIGHT=params[1];
    unsigned long rotation=params[2];
    if(rotation==0){
              s_col = y1;
              e_col = y2;
              s_page = (unsigned short)((SSD1963DISPLAYHEIGHT - 1) - (x2));
              e_page = (unsigned short)((SSD1963DISPLAYHEIGHT - 1) - (x1));
              xtest=params[1];
              ytest=params[0];
      }
     if(rotation==1){
              s_col = (unsigned short)((SSD1963DISPLAYWIDTH - 1) - (y2));
              e_col = (unsigned short)((SSD1963DISPLAYWIDTH - 1) - y1);
              s_page = x1;
              e_page = x2;
              xtest=params[1];
              ytest=params[0];
       }
     if(rotation==2){
              s_col = x1;
              e_col = x2;
              s_page = y1;
              e_page = y2;
              xtest=params[0];
              ytest=params[1];
      }
      if(rotation==3){
              s_col = (unsigned short)((SSD1963DISPLAYWIDTH - 1) - (x2));
              e_col = (unsigned short)((SSD1963DISPLAYWIDTH - 1) - (x1));
              s_page = (unsigned short)((SSD1963DISPLAYHEIGHT - 1) - (y2));
              e_page = (unsigned short)((SSD1963DISPLAYHEIGHT - 1) - (y1));
              xtest=params[0];
              ytest=params[1];
       }
    // convert the colours to 666 format
    fhb = ((fc >> 15) & 0b111111000) | ((fc >> 13) & 0b000000111);
    flb = ((fc >>  4) & 0b111000000) | ((fc >>  2) & 0b000111111);
    bhb = ((bc >> 15) & 0b111111000) | ((bc >> 13) & 0b000000111);
    blb = ((bc >>  5) & 0b111000000) | ((bc >>  2) & 0b000111111);
    setxy(s_col,e_col,s_page,e_page, params);
    PinSetBit(rs, LATSET);                               //set CD high
    for(i = 0; i < height; i++) {                                   // step thru the font scan line by line
        for(j = 0; j < scale; j++) {                                // repeat lines to scale the font
            for(k = 0; k < width; k++) {                            // step through each bit in a scan line
                for(m = 0; m < scale; m++) {                        // repeat pixels to scale in the x axis
                    if(x1 + k * scale + m >= 0 && x1 + k * scale + m < xtest && y1 + i * scale + j >= 0 && y1 + i * scale + j < ytest) {  // if the coordinates are valid
                        if((bitmap[((i * width) + k)/8] >> (((height * width) - ((i * width) + k) - 1) %8)) & 1) {
                            psend(fhb); psend(flb);
                        } else {
                            psend(bhb); psend(blb);
                        }
                    }
                }
            }
        }
    }
}
/******************************************************************************************
 Print a char on the LCD display
 Any characters not in the font will print as a space.
 If the char (or part of a char) is outside the display it will be ignored.
 The char is printed at the current location defined by CurrentX and CurrentY
*****************************************************************************************/
/*void GUIPrintChar(int fnt, int fc, int bc, char c,long long params[]) {
    unsigned char *p, *fp;
    int scale = fnt & 0b1111, height;
    fp = (unsigned char *)FontTable[fnt >> 4];
    height = fp[1];

    // to get the +, - and = chars for font 2 we fudge them by scaling up font 1
    if((fnt & 0xf0) == 0x10 && (c == '-' || c == '+' || c == '=')) {
        fp = (unsigned char *)FontTable[0];
        scale = scale * 4;
    }

    if(c >= fp[2] && c < fp[2] + fp[3]) {
        p = fp + 4 + (int)(((c - fp[2]) * fp[1] * fp[0]) / 8);
        DrawBitmap(CurrentX, CurrentY, fp[0], fp[1], scale, fc, bc, p);
    } else
        DrawRectangle(CurrentX, CurrentY, CurrentX + (fp[0] * scale), CurrentY + (fp[1] * scale), bc);

    params[4] += fp[0] * scale;
}*/
void swap(long *x, long *y){
    long temp;
    temp=*x;
    *x=*y;
    *y=temp;
}
void drawline(long long colour,long long xx0,long long yy0,
  long long xx1, long long yy1,long long params[]){
  long dx,dy,x0=xx0,y0=yy0,x1=xx1,y1=yy1,err,ystep,xstep,dp,temp,steep;
  long cl=colour;
// int steep=(abs(y1-y0))>(abs(x1-x0));
  if(y1>y0) ystep=y1-y0;
  else ystep=y0-y1;
  if(x1>x0) xstep=x1-x0;
  else xstep=x0-x1;
  steep=ystep>xstep;
  if (steep) {
    swap(&x0,&y0);
    swap(&x1,&y1);
  }
  if (x0>x1){
    swap(&x0,&x1);
    swap(&y0,&y1);
  }
  dx=x1-x0;
//  dy=abs(y1-y0);
  if(y1>y0) dy=y1-y0;
  else dy=y0-y1;
  err=dx / 2;
  if (y0<y1) {
    ystep=1;
  }
  else {
    ystep=-1;
  }
  while (x0<=x1){
    if (steep) {
      dp=localdrawPixel(cl,y0,x0,params);
    }
    else {
      dp=localdrawPixel(cl,x0,y0,params);
    }
    err=err-dy;
    if (err<0) {
      y0=y0+ystep;
      err=err+dx;
    }
    x0=x0+1;
  }
}
long long drawchar(char thechar,int thefont, long colour,long bcolour,long x,
    long y, long size,long long params[]){
    long cl=colour,bl=bcolour,height,width;
    int offsetchr,charsize,cindex;
    unsigned char* p;

    //Point p at the font bitmap
    p=FontTable[thefont];

    //Return the Height and Width of the font
    height=p[1];
    width=p[0];
    if((thechar>=p[2]) && (thechar<(p[2]+p[3]))){
        offsetchr=thechar - p[2]; //remove the ascii offset
        charsize= ((int)p[0] * (int)p[1] ) >>3 ;//number of bytes per char
        cindex=offsetchr*charsize + 4;
        p+=cindex;
        DBitmap(x, y, width, height, size, cl, bl, p,  params );
    }
    else {
       localfastfillrect(bcolour,x, y, width*size,height*size, params) ;
    }
}
long testchar(long x, long y, long sz, long width,long long params[]){
        unsigned long rotation=params[2];
        long wi=params[0],ht=params[1];
        x=x+(width*sz);
        if(((rotation==2) || (rotation==3)) && ((x<0) || (y<0) || (x>wi) || y>ht)){
            return 0;
        } 
        if(((rotation==0) || (rotation==1)) && ((x<0) || (y<0) || (x>ht) || y>wi)){
            return 0;
        }
        return 1;
}
long long pstring(long long afont,long long xx, long long yy,long long size,
        long long fc, long long bc,long long params[],unsigned char text[]){
    long x=xx,y=yy,sz=size,fontcolour=fc,backgroundcolour=bc;
    long i,width;
    long long myreturn;
    unsigned char* p;

    //Point p at the font bitmap
    p=FontTable[afont];

    //Return the Height and Width of the font
    width=p[0];
      for(i=1;i<=(long)text[0];i++)
      {
        if(testchar(x,y,sz,width,params)) { //Only write characters that will complete on the screen
            myreturn=drawchar(text[i],afont,fontcolour,backgroundcolour, x, y, sz, params);
            x=x+(width*sz);
        }else{
            return 0;
        }
      }

    params[4]=x;
    params[5]=y;
    return myreturn;
}
long long dcirch( long long colour, long long xx0,
   long long yy0, long long rr,long long ccn, long long params[]){
   long r=rr, f=1-r, ddF_x=1, ddF_y=-2 * r, x=0, y=r, dp,x0=xx0,y0=yy0,cn=ccn;
   long cl=colour;
   if(cn&16){
     dp=localdrawPixel(cl, x0, y0+r,  params);
     dp=localdrawPixel(cl, x0, y0-r,  params);
     dp=localdrawPixel(cl, x0+r, y0,  params);
     dp=localdrawPixel(cl, x0-r, y0,  params);
   }
   while (x<y){
    if (f>=0){
      y=y-1;
      ddF_y=ddF_y+2;
      f=f+ddF_y;
    }
    x=x+1;
    ddF_x=ddF_x+2;
    f=f+ddF_x;
    if(cn&4){
      dp=localdrawPixel(cl, x0+x, y0+y,  params);
      dp=localdrawPixel(cl, x0+y, y0+x,  params);
    }
    if(cn&2){
      dp=localdrawPixel(cl, x0+x, y0-y,  params);
      dp=localdrawPixel(cl, x0+y, y0-x,  params);
    }
    if(cn&8){
      dp=localdrawPixel(cl, x0-y, y0+x,  params);
      dp=localdrawPixel(cl, x0-x, y0+y,  params);
    }
    if(cn&1){
      dp=localdrawPixel(cl, x0-y, y0-x,  params);
      dp=localdrawPixel(cl, x0-x, y0-y,  params);
     }
   }
}
void fcirch(long long xx0,long long yy0,long long rr,
  long long ccn, long long d,long long colour,long long params[]){
  long r=rr, dp, f=1-r, ddF_x=1, ddF_y=-2 * r, x=0, y=r,x0=xx0,y0=yy0,cn=ccn,delta=d;
  while (x<y){
    if (f>=0) {
      y=y-1;
      ddF_y=ddF_y+2;
      f=f+ddF_y;
    }
    x=x+1;
    ddF_x=ddF_x+2;
    f=f+ddF_x;
    if (cn & 1) {
      dp=localfastfillrect(colour, x0+x, y0-y, 1, 2*y+1+delta, params) ;
      dp=localfastfillrect(colour, x0+y, y0-x, 1, 2*x+1+delta, params) ;
    }
    if (cn & 2) {
      dp=localfastfillrect(colour, x0-x, y0-y, 1, 2*y+1+delta,  params) ;
      dp=localfastfillrect(colour, x0-y, y0-x, 1, 2*x+1+delta,  params) ;
    }
  }
}
void ftri (long long xx0 , long long yy0, long long xx1,long long yy1, long long xx2, long long yy2, long long colour,long long params[]) {
  long a, b, y, dp, last,x0=xx0,y0=yy0,x1=xx1,y1=yy1,x2=xx2,y2=yy2;
  if (y0>y1) {
    swap(&y0, &y1);
    swap(&x0, &x1);
  }
  if (y1>y2) {
    swap(&y2, &y1);
    swap(&x2, &x1);
  }
  if (y0>y1) {
    swap(&y0, &y1);
    swap(&x0, &x1);
  }
  if(y0==y2) { // Handle awkward all-on-same-line case as its own thing
    a=x0;
    b=x0;
    if(x1<a) {
      a=x1;
    } else {
       if(x1>b) b=x1;
    }
    if(x2<a) {
      a=x2;
    } else {
      if(x2>b)  b=x2;
    }
    dp=localfastfillrect( colour, a, y0, 1, b-a+1,  params) ;
  } else {
    long  dx01=x1-x0,  dy01=y1-y0,  dx02=x2-x0,  dy02=y2-y0, dx12=x2-x1,  dy12=y2-y1,  sa=0, sb=0;
    if(y1==y2) {
      last=y1; //Include y1 scanline
    } else {
     last=y1-1; // Skip it
    }
    for (y=y0;y<=last;y++){
      a=x0+sa / dy01;
      b=x0+sb / dy02;
      sa=sa+dx01;
      sb=sb+dx02;
      a=x0+(x1-x0) * (y-y0) / (y1-y0);
      b=x0+(x2-x0) * (y-y0) / (y2-y0);
      if(a>b)swap(&a, &b);
      dp=localfastfillrect( colour, a, y, b-a+1, 1,  params) ;
     }
     sa=dx12 * (y-y1);
     sb=dx02 * (y-y0);
     while (y<=y2){
       a=x1+sa / dy12;
       b=x0+sb / dy02;
       sa=sa+dx12;
       sb=sb+dx02;
       a=x1+(x2-x1) * (y-y1) / (y2-y1);
       b=x0+(x2-x0) * (y-y0) / (y2-y0);
       if(a>b) swap(&a, &b);
       dp=localfastfillrect( colour, a, y, b-a+1, 1,  params) ;
       y=y+1;
     }
  }
}
long long main(long long *fn, long long *Arg1, long long *Arg2, long long *Arg3,
long long *Arg4, long long *Arg5,long long *Arg6, long long *Arg7,long long *Arg8, char *Arg9) {
    long long i;

    //Note 'if' statements are used rather than 'switch, case' because
    //'switch case' can generate 'peculiar' code resulting in JLR instructions
    //

    if (*fn==0x0){
        i=localdrawPixel((int)*Arg1,(int)*Arg2,(int)*Arg3,Arg4);
        return(i);
    }
    if (*fn==0x1){
        i=localfastfillrect((long long)*Arg1,(long long)*Arg2,(long long)*Arg3,(long long)*Arg4,
                (long long)*Arg5,Arg6);
        return(i);
    }
    if (*fn==0x2){
        ftri((long long)*Arg1,(long long)*Arg2,(long long)*Arg3,(long long)*Arg4,(long long)*Arg5,(long long)*Arg6,(long long)*Arg7,Arg8);
        return(*fn);
    }
    if (*fn==0x3){
        drawline((long long)*Arg1,(long long)*Arg2,(int)*Arg3,(int)*Arg4,
                (int)*Arg5,Arg6);
        return(*fn);
    }
    if (*fn==0x4){
        writeCommand((long long)*Arg1,Arg2);
        return(*fn);
    }
    if (*fn==0x5){
        writeData((long long)*Arg1,Arg2);
        return(*fn);
    }
    if (*fn==0x7){
        i=pstring((long long)*Arg1,(long long)*Arg2,(long long)*Arg3,(long long)*Arg4,(long long)*Arg5,(long long)*Arg6,Arg7,(char*)Arg8);
        return(i);
    }
    if (*fn==0x8){
        fcirch((long long)*Arg1,(long long)*Arg2,(long long)*Arg3,(long long)*Arg4,(long long)*Arg5,(long long)*Arg6,Arg7);
        return(*fn);
    }
    if (*fn==0x9){
        dcirch((long long)*Arg1,(long long)*Arg2,(long long)*Arg3,(long long)*Arg4,(long long)*Arg5,Arg6);
        return(*fn);
    }
     if (*fn==0xA){
        DBitmap((int)*Arg1,(int)*Arg2,(int)*Arg3,(int)*Arg4,(int)*Arg5,(int)*Arg6,(int)*Arg7, (char*)Arg8, (long long*)Arg9 );
       return 0;
     }
}
